// CSGTedlg.cpp : implementation file
// This is the implementation of the main dialog.  The majority of the code for this application
// resides in this file.  This includes OLE initialization and the calling of CSG OLE interface
// methods.

#include "stdafx.h"
#include "CSGTestC.h"
#include "CSGTedlg.h"
#include "procs.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

extern int ReplyReceived;
extern CCSGTestCApp theApp;

// About Dialog generated via AppWizard
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
   {
   public:
	   CAboutDlg();

   // Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

   // Implementation
   protected:
	   virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	   //{{AFX_MSG(CAboutDlg)
	   virtual BOOL OnInitDialog();
	   //}}AFX_MSG
	   DECLARE_MESSAGE_MAP()
   };  // class CAboutDlg

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
   {
   //{{AFX_DATA_INIT(CAboutDlg)
   //}}AFX_DATA_INIT
   }  // CAboutDlg::CAboutDlg()

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
   {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
   }  // CAboutDlg::DoDataExchange

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg message handlers

BOOL CAboutDlg::OnInitDialog()
   {
	CDialog::OnInitDialog();
	CenterWindow();
	return TRUE;  
   }  // CAboutDlg::OnInitDialog()



// Portions of CCSGTestCDlg generated via AppWizard
/////////////////////////////////////////////////////////////////////////////
// CCSGTestCDlg dialog

CCSGTestCDlg::CCSGTestCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCSGTestCDlg::IDD, pParent)
   // Initialization of AFX_DATA variables declared in CSGTedlg.h
   {
	//{{AFX_DATA_INIT(CCSGTestCDlg)
	mSendText = _T("");
	mReceiveText = _T("");
	mDelay = FALSE;
	mPathmon = _T("");
	mServer = _T("");
	mOption = -1;
	mWaited = FALSE;
	mCSGName = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
   }  // CCSGTestCDlg::CCSGTestCDlg

void CCSGTestCDlg::DoDataExchange(CDataExchange* pDX)
   // Transfers data between controls on dialog box and AFX_DATA variables
   {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCSGTestCDlg)
	DDX_Control(pDX, txtReturnCode, mReturnCodeControl);
	DDX_Control(pDX, txtReplySubstatus, mReplySubstatusControl);
	DDX_Control(pDX, txtReplyStatus, mReplyStatusControl);
	DDX_Control(pDX, txtReceive, mReceiveTextControl);
	DDX_Control(pDX, chkLoop, mLoopControl);
	DDX_Control(pDX, lstCalls, mCallControl);
	DDX_Text(pDX, txtSend, mSendText);
	DDV_MaxChars(pDX, mSendText, 32000);
	DDX_Text(pDX, txtReceive, mReceiveText);
	DDV_MaxChars(pDX, mReceiveText, 32000);
	DDX_Check(pDX, chkDelay, mDelay);
	DDX_Text(pDX, txtPathmon, mPathmon);
	DDV_MaxChars(pDX, mPathmon, 15);
	DDX_Text(pDX, txtServer, mServer);
	DDV_MaxChars(pDX, mServer, 15);
	DDX_Radio(pDX, optUseDropdown, mOption);
	DDX_Check(pDX, chkWaited, mWaited);
	DDX_Text(pDX, txtCSGName, mCSGName);
	DDV_MaxChars(pDX, mCSGName, 10);
	//}}AFX_DATA_MAP
   }  // CCSGTestCDlg::DoDataExchange

// Message map relates controls and events to the correct handler
BEGIN_MESSAGE_MAP(CCSGTestCDlg, CDialog)
	//{{AFX_MSG_MAP(CCSGTestCDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(cmdSend, OncmdSend)
	ON_BN_CLICKED(cmdExit, OncmdExit)
	ON_BN_CLICKED(optCSGSend, OnoptCSGSend)
	ON_BN_CLICKED(optSRVSend, OnoptSRVSend)
	ON_BN_CLICKED(optSSGSend, OnoptSSGSend)
	ON_BN_CLICKED(optSSGSendListdev, OnoptSSGSendListdev)
	ON_BN_CLICKED(optSSGSendPrivate, OnoptSSGSendPrivate)
	ON_BN_CLICKED(optSSGSendShare, OnoptSSGSendShare)
	ON_BN_CLICKED(optSSGSendStatus, OnoptSSGSendStatus)
	ON_BN_CLICKED(optUseDropdown, OnoptUseDropdown)
	ON_BN_CLICKED(cmdStats, OncmdStats)
	ON_BN_CLICKED(cmdAbout, OncmdAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCSGTestCDlg message handlers

BOOL CCSGTestCDlg::OnInitDialog()
   {
	CDialog::OnInitDialog();
	CenterWindow();

	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	   {
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	   }
	
	// create the server objects that we'll drive through OLE automation
	COleException e;
	CLSID clsid;

	//************** CSG DLL request class ****************************
   // This is the main interface class for the CSG.  It is here that
   // we get a dispatch pointer for the CSGRequest object declared in CSGTedlg.h.

   // Get Class ID from registry; CSG OLE Interface class name is "CSGDLL.CSGClass"
	if (CLSIDFromString(OLESTR("CSGDLL.CSGClass"), &clsid) != NOERROR)
	   {
		AfxMessageBox(IDP_UNABLE_TO_CREATE);
		AfxThrowUserException();
	   }

	// Try to get the active object before creating a new one
	LPUNKNOWN lpUnk;
	LPDISPATCH lpDispatch;
	if (GetActiveObject(clsid, NULL, &lpUnk) == NOERROR)
	   {
		HRESULT hr = lpUnk->QueryInterface(IID_IDispatch, 
			(LPVOID*)&lpDispatch);
		lpUnk->Release();
		if (hr == NOERROR)
			CSGRequest.AttachDispatch(lpDispatch, TRUE);    // Have dispatch pointer
	   }

	// If not dispatch ptr attached yet, need to create one
	if (CSGRequest.m_lpDispatch == NULL && 
		!CSGRequest.CreateDispatch(clsid, &e))             // CreateDispatch gives us dispatch pointer
	   {
		AfxMessageBox(IDP_UNABLE_TO_CREATE);
		AfxThrowUserException();
	   }

 	//************** CSG DLL stats class ****************************
   // This is where we get a dispatch pointer for the CSGStats object
   // declared in CSGTedlg.h

   // Get Class ID from registry; CSG Stats class name is "CSGDLL.CSGStatsClass"
	if (CLSIDFromString(OLESTR("CSGDLL.CSGStatsClass"), &clsid) != NOERROR)
	   {
		AfxMessageBox(IDP_UNABLE_TO_CREATE);
		AfxThrowUserException();
	   }

	// Try to get the active object before creating a new one
	if (GetActiveObject(clsid, NULL, &lpUnk) == NOERROR)
	   {
		HRESULT hr = lpUnk->QueryInterface(IID_IDispatch, 
			(LPVOID*)&lpDispatch);
		lpUnk->Release();
		if (hr == NOERROR)
			CSGStats.AttachDispatch(lpDispatch, TRUE);     // Have dispatch pointer
	   }

	// If not dispatch ptr attached yet, need to create one
	if (CSGStats.m_lpDispatch == NULL && 
		!CSGStats.CreateDispatch(clsid, &e))              // CreateDispatch gives us dispatch pointer
	   {
		AfxMessageBox(IDP_UNABLE_TO_CREATE);
		AfxThrowUserException();
 	   }

	return TRUE;  // return TRUE  unless you set the focus to a control
   }  // CCSGTestCDlg::OnInitDialog

   
void CCSGTestCDlg::OnSysCommand(UINT nID, LPARAM lParam)
   {
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	   {
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	   }
	else
	   {
		CDialog::OnSysCommand(nID, lParam);
	   }
   }  // CCSGTestCDlg::OnSysCommand


void CCSGTestCDlg::OnPaint() 
   {
	if (IsIconic())
	   {
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	   }
	else
	   {
		CDialog::OnPaint();
	   }
   }  // CCSGTestCDlg::OnPaint


HCURSOR CCSGTestCDlg::OnQueryDragIcon()
   {
	return (HCURSOR) m_hIcon;
   }  // CCSGTestCDlg::OnQueryDragIcon


void CCSGTestCDlg::OncmdExit() 
   {
   // Exit clicked; call generic dialog OnCancel routine to cleanup & exit
   mLoopControl.SetCheck(0);           // Ensure that command loop is disabled
	CDialog::OnCancel();
   }  // CCSGTestCDlg::OncmdExit


void CCSGTestCDlg::OncmdSend() 
   {
   // This routine is where the work of actually sending a request is done
   static int HereBefore;              // Static flag for initialization first time through
   static CSGParamsClass Params;       // Params for call
   CSGParamsClass TParams;             // Temporary copy of params for waited calls

   USES_CONVERSION;                    // For MBCS<->Unicode conversion macros

   if (HereBefore == 0)
      {
      // Initialize static variables.
      // For the purposes of this example many values are fixed.  This includes 
      // the client name, replay key, tag, term, age/generation, cache index, client
      // context, and timeout variables.  These values are contained in the Params object,
      // and the majority of them have been initialized via the class constructor to 
      // default values.  The Reply dispatch pointer and client name params are set here.
      HereBefore = -1;                                                     // Flag for next time
      Params.ReplyDispatch = MyReplyObject.GetIDispatch(FALSE);            // Pointer to our reply object
      Params.ClientName = theApp.MyName.SetSysString(&Params.ClientName);  // Same client name on each call; use CString method AllocSysString
      }

   UpdateData();                                                 // Get data from dialog into member vars

   // Now init Pathmon , Server, and/or CSGName if specified.  Note that this uses the CString
   // member function AllocSysString to return a BSTR from a CString, or SysAllocString to return a BSTR from a standard
   // C/ANSI string.
   mPathmon.TrimLeft();
   if (mPathmon.IsEmpty())
      SysReAllocString(&Params.Pathmon, OLESTR("*"));            // Use default Pathmon value of "*"
   else
      Params.Pathmon = mPathmon.SetSysString(&Params.Pathmon);   // Get BSTR from CString 
   Params.VPathmon.pbstrVal = &Params.Pathmon;                   // Set variant to use new BSTR
   
   mServer.TrimLeft();
   if (mServer.IsEmpty())
      SysReAllocString(&Params.Server, OLESTR("*"));             // Use default server value of "*"
   else
      Params.Server = mServer.SetSysString(&Params.Server);      // Get BSTR from CString
   Params.VServer.pbstrVal = &Params.Server;                     // Set variant to use new BSTR
  
   mCSGName.TrimLeft();
   if (mCSGName.IsEmpty())
      SysReAllocString(&Params.CSGName, OLESTR("*"));            // Use default CSG name of "*"
   else
      Params.CSGName = mCSGName.SetSysString(&Params.CSGName);   // Get BSTR from CString
   Params.VCSGName.pbstrVal = &Params.CSGName;                   // Set variant to use new BSTR

   // If waited save Params, since waited return will overwrite values
   if (mWaited)                                                  
      TParams = Params;

   // Params are set; now begin determining the call type 
   if ((OptionSelected == optUseDropdown) && (mCallControl.GetCurSel() == LB_ERR))
      {
      // If the dropdown is being used and no item is selected, select the first
      mCallControl.SetCurSel(0);
	   }

   // Command loop; if the loop check box is not checked, we execute the code once and drop out; otherwise we
   // keep looping until the check box is cleared.
   do
      {
      DoSend(OptionSelected, &Params, &TParams);
      // If looping and using drop down, get next command
      if ((OptionSelected == optUseDropdown) && (mLoopControl.GetCheck()))
         mCallControl.SetCurSel((mCallControl.GetCurSel() + 1) % mCallControl.GetCount());
      }  // do loop
   while (mLoopControl.GetCheck());

   }  //CCSGTestCDlg::OncmdSend


short CCSGTestCDlg::DoSend(long OptionSelected, CSGParamsClass *Params, CSGParamsClass *TParams)
   {
  	// Send the request to the host, based on OptionSelected, using the parameters given by Params   
   CString ThisCommand;                // Parsed command
   CString ThisToken;                  // Parsed token
   long    CallOption;                 // Which call to make
   short   ReturnCode;                 // Return code from CSG call
   char    ReturnCodeString[10];       // Return code converted to ASCII
   short   i;                          // Temporary index

   USES_CONVERSION;                    // For MBCS<->Unicode conversion macros

   if (OptionSelected == optUseDropdown)
	   {
      // If we're using the dropdown, parse the command.  Assume it's of the format <CALL><call specific data>
      // Then change the selected option to the appropriate call.  
      // Get data from control
	   mCallControl.GetLBText(mCallControl.GetCurSel(), ThisCommand);
      ThisCommand.TrimLeft();
      ThisToken = GetSpaceDelimitedToken(&ThisCommand);
      if (ThisToken.IsEmpty()) 
         return 0;                                     // No token found; punt
      ThisCommand.TrimLeft();
      ThisToken.MakeUpper();
      if (ThisToken == "SSGSEND")
         CallOption = optSSGSend;
      else if (ThisToken == "SSGSENDPRIVATE")
         CallOption = optSSGSendPrivate;
      else if (ThisToken == "SSGSENDSHARE")
         CallOption = optSSGSendShare;
      else if (ThisToken == "SSGSENDSTATUS")
         CallOption = optSSGSendStatus;
      else if (ThisToken == "SSGSENDLISTDEV")
         CallOption = optSSGSendListdev;
      else if (ThisToken == "SRVSEND")
         CallOption = optSRVSend;
      else if (ThisToken == "CSGSEND")
         CallOption = optCSGSend;
      else 
         CallOption = -1;                              // Error
      }  // if dropdown list
   else
      // Move mSendText field to ThisCommand, set CallOption to OptionSelected   
      {
      ThisCommand = mSendText;
      ThisCommand.TrimLeft();
	   CallOption = OptionSelected;
      }
	   
   // Call is set up; CallOption contains the id of the call to make.  
   ReplyReceived = FALSE;                              // No reply received yet
   // Make call based on selected option  
   switch(CallOption)
      {	  
      case optSSGSend:
         // ThisCommand contains text to send (i.e. <REQUEST>)
         Params->Message = ThisCommand.SetSysString(&Params->Message);
         if (mWaited)
            ReturnCode = CSGRequest.SSGSendWait(&Params->Status, &Params->SubStatus, &Params->ClientName, &Params->Message, &Params->VCSGName,
                                                &Params->VReplayKey, &Params->VPathmon, &Params->VServer, &Params->VClientContext, &Params->VTimeout);
         else
            ReturnCode = CSGRequest.SSGSend(&Params->ReplyDispatch, &Params->ClientName, &Params->Message, &Params->VCSGName, &Params->VReplayKey, 
                                            &Params->VPathmon, &Params->VServer, &Params->VClientContext, &Params->VRequestID);
         break;
      case optSSGSendPrivate:
         // ThisCommand contains <CI> <REQUEST>
         Params->CI = GetSpaceDelimitedToken(&ThisCommand).SetSysString(&Params->CI);
         ThisCommand.TrimLeft();
         Params->Message = ThisCommand.SetSysString(&Params->Message);
         if (mWaited)
            ReturnCode = CSGRequest.SSGSendPrivateWait(&Params->Status, &Params->SubStatus, &Params->ClientName, &Params->CI, &Params->Message,
                                                       &Params->VCSGName, &Params->VCacheIndex, &Params->VTag, &Params->VTerm, &Params->VReplayKey,
                                                       &Params->VPathmon, &Params->VServer, &Params->VClientContext, &Params->VTimeout);
         else
            ReturnCode = CSGRequest.SSGSendPrivate(&Params->ReplyDispatch, &Params->ClientName, &Params->CI, &Params->Message, &Params->VCSGName,
                                                   &Params->VCacheIndex, &Params->VTag, &Params->VTerm, &Params->VReplayKey, &Params->VPathmon,
                                                   &Params->VServer, &Params->VClientContext, &Params->VRequestID);
         break;
      case optSSGSendShare:
         // ThisCommand contains <CI> <REQUEST>
         Params->CI = GetSpaceDelimitedToken(&ThisCommand).SetSysString(&Params->CI);
         ThisCommand.TrimLeft();
         Params->Message = ThisCommand.SetSysString(&Params->Message);
         if (mWaited)
            ReturnCode = CSGRequest.SSGSendShareWait(&Params->Status, &Params->SubStatus, &Params->ClientName, &Params->CI, &Params->Message, 
                                                     &Params->VCSGName, &Params->VAgeGen, &Params->VCacheIndex, &Params->VTag, &Params->VTerm,
                                                     &Params->VReplayKey, &Params->VPathmon, &Params->VServer, &Params->VClientContext,
                                                     &Params->VTimeout);
         else
            ReturnCode = CSGRequest.SSGSendShare(&Params->ReplyDispatch, &Params->ClientName, &Params->CI, &Params->Message, &Params->VCSGName, 
					                                  &Params->VAgeGen, &Params->VCacheIndex, &Params->VTag, &Params->VTerm, &Params->VReplayKey,
		                                           &Params->VPathmon, &Params->VServer, &Params->VClientContext, &Params->VRequestID);
         break;
      case optSSGSendStatus:
         // ThisCommand contains <REQUEST>
         Params->Message = ThisCommand.SetSysString(&Params->Message);
         if (mWaited)
            ReturnCode = CSGRequest.SSGSendStatusWait(&Params->Status, &Params->SubStatus, &Params->ClientName, &Params->Message, &Params->VCSGName,
                                                      &Params->VReplayKey, &Params->VPathmon, &Params->VServer, &Params->VClientContext,
                                                      &Params->VTimeout);
         else
            ReturnCode = CSGRequest.SSGSendStatus(&Params->ReplyDispatch, &Params->ClientName, &Params->Message, &Params->VCSGName, 
                                                  &Params->VReplayKey, &Params->VPathmon, &Params->VServer, &Params->VClientContext, &Params->VRequestID);
         break;
      case optSSGSendListdev:
         // ThisCommand contains <REQUEST>
         Params->Message = ThisCommand.SetSysString(&Params->Message);
         if (mWaited)
            ReturnCode = CSGRequest.SSGSendListdevWait(&Params->Status, &Params->SubStatus, &Params->ClientName, &Params->Message, &Params->VCSGName,
                                                       &Params->VCacheIndex, &Params->VTag, &Params->VTerm, &Params->VReplayKey, &Params->VPathmon,
                                                       &Params->VServer, &Params->VClientContext, &Params->VTimeout);
         else
            ReturnCode = CSGRequest.SSGSendListdev(&Params->ReplyDispatch, &Params->ClientName, &Params->Message, &Params->VCSGName,
                                                   &Params->VCacheIndex, &Params->VTag, &Params->VTerm, &Params->VReplayKey, &Params->VPathmon,
                                                   &Params->VServer, &Params->VClientContext, &Params->VRequestID);
         break;
      case optSRVSend:
         // ThisCommand contains <REQUEST>
         Params->Message = ThisCommand.SetSysString(&Params->Message);
         if (mWaited)
            ReturnCode = CSGRequest.SRVSendWait(&Params->Status, &Params->SubStatus, &Params->ClientName, &Params->Message, &Params->VCSGName, 
                                                &Params->VReplayKey, &Params->VPathmon, &Params->VServer, &Params->VClientContext, &Params->VTimeout);
         else
            ReturnCode = CSGRequest.SRVSend(&Params->ReplyDispatch, &Params->ClientName, &Params->Message, &Params->VCSGName, &Params->VReplayKey, 
                                            &Params->VPathmon, &Params->VServer, &Params->VClientContext, &Params->VRequestID);
         break;
      case optCSGSend:
         // ThisCommand contains <REQUEST>
         Params->Message = ThisCommand.SetSysString(&Params->Message);
         if (mWaited)
            ReturnCode = CSGRequest.CSGSendWait(&Params->Status, &Params->SubStatus, &Params->ClientName, &Params->Message, &Params->VCSGName,
                                                &Params->VClientContext, &Params->VTimeout);
         else
            ReturnCode = CSGRequest.CSGSend(&Params->ReplyDispatch, &Params->ClientName, &Params->Message, &Params->VCSGName, &Params->VClientContext, 
			                                   &Params->VRequestID);
         break;
      default: 
         MessageBox("Unknown option", "Send Result", MB_OK|MB_ICONEXCLAMATION); 
         break; 
      } //switch

   // Update return code on main dialog
   for(i = 0; i < 10; i++) ReturnCodeString[i] = '\0';
   _itoa(ReturnCode, ReturnCodeString, 10);
   mReturnCodeControl.SetSel(0, -1);
   mReturnCodeControl.ReplaceSel(&ReturnCodeString[0]);

   if (mWaited)
      {
      // If waited then display the results and restore parameters
      SetReplyMemberVars(Params->Status, Params->SubStatus, OLE2CT(Params->Message), CallOption);
      *Params = *TParams;
      }
   else
      {
      if (mLoopControl.GetCheck())
         // If looping and not waited, wait for response before sending next request
         WaitForResource(&ReplyReceived, TRUE);
      }

   // Clean up string vars
   ThisCommand.Empty();
   ThisToken.Empty();

   return 0;
   }  // CCSGTestCDlg::DoSend


void CCSGTestCDlg::OncmdStats() 
   {
   // Display CSG stats
   CSGStats.ShowStats();	
   }  // CCSGTestCDlg::OncmdStats


void CCSGTestCDlg::OncmdAbout() 
   {
	// Show about box
   CAboutDlg dlgAbout;
	
   dlgAbout.DoModal();
   }  // CCSGTestCDlg::OncmdAbout


void CCSGTestCDlg::OnoptCSGSend() 
   {
	OptionSelected = optCSGSend;   	   	
   }  // CCSGTestCDlg::OnoptCSGSend


void CCSGTestCDlg::OnoptSRVSend() 
   {
	OptionSelected = optSRVSend;   	   	
   }  // CCSGTestCDlg::OnoptSRVSend

void CCSGTestCDlg::OnoptSSGSend() 
   {
	OptionSelected = optSSGSend;   	   	
   }  // CCSGTestCDlg::OnoptSSGSend


void CCSGTestCDlg::OnoptSSGSendListdev() 
   {
	OptionSelected = optSSGSendListdev;   	   	
   }  // CCSGTestCDlg::OnoptSSGSendListdev


void CCSGTestCDlg::OnoptSSGSendPrivate() 
   {
	OptionSelected = optSSGSendPrivate;   	   	
   }  // CCSGTestCDlg::OnoptSSGSendPrivate


void CCSGTestCDlg::OnoptSSGSendShare() 
   {
	OptionSelected = optSSGSendShare;   	   	
   }  // CCSGTestCDlg::OnoptSSGSendShare

void CCSGTestCDlg::OnoptSSGSendStatus() 
   {
	OptionSelected = optSSGSendStatus;   	   	
   }  // CCSGTestCDlg::OnoptSSGSendStatus


void CCSGTestCDlg::OnoptUseDropdown() 
   {
	OptionSelected = optUseDropdown;
   }  // CCSGTestCDlg::OnoptUseDropdown

// ***** End of file CSGTedlg.cpp *****

