// replycla.h : header file
// This file contains the definition of the call back reply class.  The handle of an object of
// this type is passed to the CSG; the CSG in turn uses this object to "call back" to the 
// client application with response data.



/////////////////////////////////////////////////////////////////////////////
// ReplyClass command target

class ReplyClass : public CCmdTarget
   {
	   DECLARE_DYNCREATE(ReplyClass)
   protected:

   // Attributes
   public:

   // Operations
   public:
	   ReplyClass();           // constructor used by dynamic creation
       virtual ~ReplyClass();

   // Overrides
	   // ClassWizard generated virtual function overrides
	   //{{AFX_VIRTUAL(ReplyClass)
	   public:
	   virtual void OnFinalRelease();
	   //}}AFX_VIRTUAL

   // Implementation
   protected:

	   // Generated message map functions
	   //{{AFX_MSG(ReplyClass)
	   //}}AFX_MSG

	   DECLARE_MESSAGE_MAP()
	   // Generated OLE dispatch map functions                                  
	   //{{AFX_DISPATCH(ReplyClass)
	   afx_msg short CSGReply(short * Status, short  * SubStatus, LPCTSTR Reply, LPCTSTR ClientContext, LPCTSTR RequestID);
	   afx_msg short SSGReply(short * Status, short * SubStatus, LPCTSTR Reply, LPCTSTR Pathmon, LPCTSTR Server, LPCTSTR ClientContext, LPCTSTR RequestID);
	   afx_msg short SSGReplyPrivate(short * Status, short * SubStatus, LPCTSTR CI, LPCTSTR Reply, LPCTSTR CacheIndex, LPCTSTR Tag, LPCTSTR Term, LPCTSTR Pathmon, LPCTSTR Server, LPCTSTR ClientContext, LPCTSTR RequestID);
	   afx_msg short SSGReplyShare(short * Status, short * SubStatus, LPCTSTR CI, LPCTSTR Reply, LPCTSTR AgeGen, LPCTSTR CacheIndex, LPCTSTR Tag, LPCTSTR Term, LPCTSTR Pathmon, LPCTSTR Server, LPCTSTR ClientContext, LPCTSTR RequestID);
	   afx_msg short SSGReplyStatus(short * Status, short * SubStatus, LPCTSTR Reply, LPCTSTR Pathmon, LPCTSTR Server, LPCTSTR ClientContext, LPCTSTR RequestID);
	   afx_msg short SSGReplyListdev(short * Status, short * SubStatus, LPCTSTR Reply, LPCTSTR CacheIndex, LPCTSTR Tag, LPCTSTR Term, LPCTSTR Pathmon, LPCTSTR Server, LPCTSTR ClientContext, LPCTSTR RequestID);
	   afx_msg short SRVReply(short * Status, short * SubStatus, LPCTSTR Reply, LPCTSTR Pathmon, LPCTSTR Server, LPCTSTR ClientContext, LPCTSTR RequestID);
	   //}}AFX_DISPATCH
	   DECLARE_DISPATCH_MAP()
   };  // ReplyClass

/////////////////////////////////////////////////////////////////////////////

// ***** End of file replycla.h *****

